# Change Log for PseuCo Language

## 2.0.0

### Added
- Documentation

### Changed
- Major change: Removed `ClassDeclaration` type and added `MonitorDeclaration` and `StructDeclaration` instead.
- Major change: Removed from type `ValueType` all types except BOOL, INT, and STRING.

## 1.0.1

### Changed

- Updated parser generator to Peggy 2.0.1
- Exporting PeggySyntaxError
- Added `options` argument to `parse` function
- Using Peggy's native `error` function to throw for syntax errors not captured by the grammar
- Renamed "Parser.ts", respectively, "dist/Parser.js" into "parser-generated.ts" ("parser-generated.js") to make clear that these files are generated

## 1.0

### Changed

- Reimplementation in TypeScript
- Static semantics has been layed off to @pseuco/static-semantics
- Changed license to MIT

## 0.9.1 - 2021-01-26

### Changed

- Detect and reject nested procedure declarations.

### Fixed

- Potentially incorrect type checking after redeclaration of procedures.

## 0.9.0 - 2020-10-27

### Added

- Support for assertions via `assert(<boolean expression>)`.

## 0.8.5 - 2020-06-04

### Fixed

- Unexpected exceptions (i.e., exceptions that are not used to propagate pseuCo type errors but indicate implementation mistakes of the type checking itself) are now propagated up to the caller of the type checking process. Previously, such exceptions might have been discarded, which led to ill-typed programs being accepted as well typed.

## 0.8.4 - 2020-06-03

### Fixed

- Compilers relying on AST method `getType` did not working properly.

## 0.8.3 - 2019-05-31

### Added

- Introducing change log file

### Changed

- Allow array expressions on left side of the dot of class call expressions. E.g., `a[0].f()` was rejected with a syntax error.

