const pegjs = require("peggy");
const tspegjs = require("ts-pegjs");
const fs = require("fs")

const pseucoPEGFile = fs.readFileSync("src/PseuCoParser.pegjs").toString()

let parser = pegjs.generate(pseucoPEGFile, {
    output: "source",
    format: "commonjs",
    plugins: [tspegjs],
    "tspegjs": {
        "customHeader": "import { Program, ConditionDeclaration, MainAgent, Monitor, ProcedureDeclaration, ProcedureParameter, Struct, VariableDeclarations, VariableDeclarator, VariableInitializer, AdditiveExpression, AndExpression, ArrayExpression, AssignDestination, AssignExpression, ClassCall, ConditionalExpression, EqualityExpression, IdentifierExpression, LiteralExpression, ValueType, MultiplicativeExpression, OrExpression, PostfixExpression, ProcedureCall, ReceiveExpression, RelationalExpression, SendExpression, StartExpression, UnaryExpression, BreakStatement, Case, ContinueStatement, DoStatement, ForInit, ForStatement, IfStatement, PrimitiveStatement, ConditionStatement, PrintStatement, ReturnStatement, SelectStatement, StatementBlock, StatementExpression, StatementWrapper, WhileStatement, ArrayTypeNode, ChannelTypeNode, ClassTypeNode, SimpleTypeNode, ValueWrapper } from './ast/index';"
    },
    "returnTypes": {
        "Program": "Program",
        "StatementBlock": "StatementBlock"
    }
});

// Concretise the return value type of the parser
parser = "/* THIS FILE WAS GENERATED BY run-peg.js! */\n\n" + parser.replace(
    "export type ParseFunction = (input: string, options?: ParseOptions) => any;",
    "export type ParseFunction = (input: string, options?: ParseOptions) => Program;"
);

fs.writeFileSync("src/parser-generated.ts", parser)

console.log("Parser generated into 'src/parser-generated.ts'.")