import * as ast from "./index";
import { NotImplementedException } from "../pseuco/constants";
import { AbstractVisitor } from "./AbstractVisitor";



/**
 * Implementation of the pseuCo AST visitor interface, where each method throws a not-implemented exception.
 */
export class Visitor<T> extends AbstractVisitor<T> {

    visitProgram(node: ast.Program, context?: unknown): T {
        throw NotImplementedException();
    }

    visitMainAgent(node: ast.MainAgent, context?: unknown): T {
        throw NotImplementedException();
    }

    visitProcedureDeclaration(node: ast.ProcedureDeclaration, context?: unknown): T {
        throw NotImplementedException();
    }

    visitProcedureParameter(node: ast.ProcedureParameter, context?: unknown): T {
        throw NotImplementedException();
    }

    visitMonitor(node: ast.Monitor, context?: unknown): T {
        throw NotImplementedException();
    }

    visitStruct(node: ast.Struct, context?: unknown): T {
        throw NotImplementedException();
    }

    visitConditionDeclaration(node: ast.ConditionDeclaration, context?: unknown): T {
        throw NotImplementedException();
    }

    visitVariableDeclarations(node: ast.VariableDeclarations, context?: unknown): T {
        throw NotImplementedException();
    }

    visitVariableDeclarator(node: ast.VariableDeclarator, context?: unknown): T {
        throw NotImplementedException();
    }

    visitVariableInitializer(node: ast.VariableInitializer, context?: unknown): T {
        throw NotImplementedException();
    }

    visitArrayTypeNode(node: ast.ArrayTypeNode, context?: unknown): T {
        throw NotImplementedException();
    }

    visitSimpleTypeNode(node: ast.SimpleTypeNode, context?: unknown): T {
        throw NotImplementedException();
    }

    visitChannelTypeNode(node: ast.ChannelTypeNode, context?: unknown): T {
        throw NotImplementedException();
    }

    visitClassTypeNode(node: ast.ClassTypeNode, context?: unknown): T {
        throw NotImplementedException();
    }

    visitStartExpression(node: ast.StartExpression, context?: unknown): T {
        throw NotImplementedException();
    }

    visitAssignExpression(node: ast.AssignExpression, context?: unknown): T {
        throw NotImplementedException();
    }

    visitAssignDestination(node: ast.AssignDestination, context?: unknown): T {
        throw NotImplementedException();
    }

    visitSendExpression(node: ast.SendExpression, context?: unknown): T {
        throw NotImplementedException();
    }

    visitConditionalExpression(node: ast.ConditionalExpression, context?: unknown): T {
        throw NotImplementedException();
    }

    visitOrExpression(node: ast.OrExpression, context?: unknown): T {
        throw NotImplementedException();
    }

    visitAndExpression(node: ast.AndExpression, context?: unknown): T {
        throw NotImplementedException();
    }

    visitEqualityExpression(node: ast.EqualityExpression, context?: unknown): T {
        throw NotImplementedException();
    }

    visitRelationalExpression(node: ast.RelationalExpression, context?: unknown): T {
        throw NotImplementedException();
    }

    visitAdditiveExpression(node: ast.AdditiveExpression, context?: unknown): T {
        throw NotImplementedException();
    }

    visitMultiplicativeExpression(node: ast.MultiplicativeExpression, context?: unknown): T {
        throw NotImplementedException();
    }

    visitUnaryExpression(node: ast.UnaryExpression, context?: unknown): T {
        throw NotImplementedException();
    }

    visitPostfixExpression(node: ast.PostfixExpression, context?: unknown): T {
        throw NotImplementedException();
    }

    visitReceiveExpression(node: ast.ReceiveExpression, context?: unknown): T {
        throw NotImplementedException();
    }

    visitProcedureCall(node: ast.ProcedureCall, context?: unknown): T {
        throw NotImplementedException();
    }

    visitClassCall(node: ast.ClassCall, context?: unknown): T {
        throw NotImplementedException();
    }

    visitArrayExpression(node: ast.ArrayExpression, context?: unknown): T {
        throw NotImplementedException();
    }

    visitLiteralExpression(node: ast.LiteralExpression, context?: unknown): T {
        throw NotImplementedException();
    }

    visitIdentifierExpression(node: ast.IdentifierExpression, context?: unknown): T {
        throw NotImplementedException();
    }

    visitStatementWrapper(node: ast.StatementWrapper, context?: unknown): T {
        throw NotImplementedException();
    }

    visitBreakStatement(node: ast.BreakStatement, context?: unknown): T {
        throw NotImplementedException();
    }

    visitContinueStatement(node: ast.ContinueStatement, context?: unknown): T {
        throw NotImplementedException();
    }

    visitStatementBlock(node: ast.StatementBlock, context?: unknown): T {
        throw NotImplementedException();
    }

    visitStatementExpression(node: ast.StatementExpression, context?: unknown): T {
        throw NotImplementedException();
    }

    visitSelectStatement(node: ast.SelectStatement, context?: unknown): T {
        throw NotImplementedException();
    }

    visitCase(node: ast.Case, context?: unknown): T {
        throw NotImplementedException();
    }

    visitConditionStatement(node: ast.ConditionStatement, context?: unknown): T {
        throw NotImplementedException();
    }

    visitIfStatement(node: ast.IfStatement, context?: unknown): T {
        throw NotImplementedException();
    }

    visitWhileStatement(node: ast.WhileStatement, context?: unknown): T {
        throw NotImplementedException();
    }

    visitDoStatement(node: ast.DoStatement, context?: unknown): T {
        throw NotImplementedException();
    }

    visitForStatement(node: ast.ForStatement, context?: unknown): T {
        throw NotImplementedException();
    }

    visitForInit(node: ast.ForInit, context?: unknown): T {
        throw NotImplementedException();
    }

    visitReturnStatement(node: ast.ReturnStatement, context?: unknown): T {
        throw NotImplementedException();
    }

    visitPrimitiveStatement(node: ast.PrimitiveStatement, context?: unknown): T {
        throw NotImplementedException();
    }

    visitPrintStatement(node: ast.PrintStatement, context?: unknown): T {
        throw NotImplementedException();
    }
}



