import { AbstractVisitor } from "./AbstractVisitor";
import * as ast from "./index";


/**
 * Implementation of the pseuCo AST visitor interface, where the return type is `void` and where the default implementation does nothing.
 */
export class VoidVisitor extends AbstractVisitor<void> {

    visitNode(node: ast.Node, context?: unknown): void {}

    visitProgram(node: ast.Program, context?: unknown): void {}

    visitMainAgent(node: ast.MainAgent, context?: unknown): void {}

    visitProcedureDeclaration(node: ast.ProcedureDeclaration, context?: unknown): void {}

    visitProcedureParameter(node: ast.ProcedureParameter, context?: unknown): void {}

    visitMonitor(node: ast.Monitor, context?: unknown): void {}

    visitStruct(node: ast.Struct, context?: unknown): void {}

    visitConditionDeclaration(node: ast.ConditionDeclaration, context?: unknown): void {}

    visitVariableDeclarations(node: ast.VariableDeclarations, context?: unknown): void {}

    visitVariableDeclarator(node: ast.VariableDeclarator, context?: unknown): void {}

    visitVariableInitializer(node: ast.VariableInitializer, context?: unknown): void {}

    visitArrayTypeNode(node: ast.ArrayTypeNode, context?: unknown): void {}

    visitSimpleTypeNode(node: ast.SimpleTypeNode, context?: unknown): void {}

    visitChannelTypeNode(node: ast.ChannelTypeNode, context?: unknown): void {}

    visitClassTypeNode(node: ast.ClassTypeNode, context?: unknown): void {}

    visitExpression(node: ast.Expression, context?: unknown): void {}

    visitStartExpression(node: ast.StartExpression, context?: unknown): void {}

    visitAssignExpression(node: ast.AssignExpression, context?: unknown): void {}

    visitAssignDestination(node: ast.AssignDestination, context?: unknown): void {}

    visitSendExpression(node: ast.SendExpression, context?: unknown): void {}

    visitConditionalExpression(node: ast.ConditionalExpression, context?: unknown): void {}

    visitOrExpression(node: ast.OrExpression, context?: unknown): void {}

    visitAndExpression(node: ast.AndExpression, context?: unknown): void {}

    visitEqualityExpression(node: ast.EqualityExpression, context?: unknown): void {}

    visitRelationalExpression(node: ast.RelationalExpression, context?: unknown): void {}

    visitAdditiveExpression(node: ast.AdditiveExpression, context?: unknown): void {}

    visitMultiplicativeExpression(node: ast.MultiplicativeExpression, context?: unknown): void {}

    visitUnaryExpression(node: ast.UnaryExpression, context?: unknown): void {}

    visitPostfixExpression(node: ast.PostfixExpression, context?: unknown): void {}

    visitReceiveExpression(node: ast.ReceiveExpression, context?: unknown): void {}

    visitProcedureCall(node: ast.ProcedureCall, context?: unknown): void {}

    visitClassCall(node: ast.ClassCall, context?: unknown): void {}

    visitArrayExpression(node: ast.ArrayExpression, context?: unknown): void {}

    visitLiteralExpression(node: ast.LiteralExpression, context?: unknown): void {}

    visitIdentifierExpression(node: ast.IdentifierExpression, context?: unknown): void {}

    visitStatementWrapper(node: ast.StatementWrapper, context?: unknown): void {}

    visitBreakStatement(node: ast.BreakStatement, context?: unknown): void {}

    visitContinueStatement(node: ast.ContinueStatement, context?: unknown): void {}

    visitStatementBlock(node: ast.StatementBlock, context?: unknown): void {}

    visitStatementExpression(node: ast.StatementExpression, context?: unknown): void {}

    visitSelectStatement(node: ast.SelectStatement, context?: unknown): void {}

    visitCase(node: ast.Case, context?: unknown): void {}

    visitConditionStatement(node: ast.ConditionStatement, context?: unknown): void {}

    visitIfStatement(node: ast.IfStatement, context?: unknown): void {}

    visitWhileStatement(node: ast.WhileStatement, context?: unknown): void {}

    visitDoStatement(node: ast.DoStatement, context?: unknown): void {}

    visitForStatement(node: ast.ForStatement, context?: unknown): void {}

    visitForInit(node: ast.ForInit, context?: unknown): void {}

    visitReturnStatement(node: ast.ReturnStatement, context?: unknown): void {}

    visitPrimitiveStatement(node: ast.PrimitiveStatement, context?: unknown): void {}

    visitPrintStatement(node: ast.PrintStatement, context?: unknown): void {}

}